.\" Copyright (c) 1983 Regents of the University of California.
.\" All rights reserved.  The Berkeley software License Agreement
.\" specifies the terms and conditions for redistribution.
.\"
.\"	@(#)lpd.8	6.3 (Berkeley) 12/8/85
.\"
.TH LPD 8 "December 8, 1985"
.UC 5
.ad
.SH NAME
lpd \- line printer daemon
.SH SYNOPSIS
.B lpd
[
.B \-l
] [ port # ]
.SH DESCRIPTION
.I Lpd
is the line printer daemon (spool area handler) and is normally invoked
at boot time from the
.IR rc (8)
file.  It makes a single pass through the
.IR printcap (5)
file to find out about the existing printers and
prints any files left after a crash. It then uses the system calls
.IR listen (2)
and
.IR accept (2)
to receive requests to print files in the queue,
transfer files to the spooling area, display the queue,
or remove jobs from the queue.  In each case, it forks a child to handle
the request so the parent can continue to listen for more requests.
The Internet port number used to rendezvous
with other processes is normally obtained with
.IR getservbyname (3)
but can be changed with the
.IR port #
argument.
The
.B \-l
flag causes
.I lpd
to log valid requests received from the network. This can be useful
for debugging purposes.
.PP
Access control is provided by two means. First, All requests must come from
one of the machines listed in the file
.I /etc/hosts.equiv
or
.IR /etc/hosts.lpd .
Second, if the ``rs'' capability is specified in the
.I printcap
entry for the printer being accessed,
.I lpr
requests will only be honored for those users with accounts on the
machine with the printer.
.PP
The file
.I minfree
in each spool directory contains the number of disk blocks to leave free
so that the line printer queue won't completely fill the disk.
The
.I minfree
file can be edited with your favorite text editor.
.PP
The file
.I lock
in each spool directory is used to prevent multiple daemons from
becoming active simultaneously, and to store information
about the daemon process for
.IR lpr (1),
.IR lpq (1),
and
.IR lprm (1).
After the daemon has successfully set the lock, it scans the directory
for files beginning with 
.IR cf .
Lines in each
.I cf
file specify files to be printed or non-printing actions to be
performed.  Each such line begins with a key character
to specify what to do with the remainder of the line.
.in +3
.IP J
Job Name.  String to be used for the job name on the burst page.
.IP C
Classification.  String to be used for the classification line
on the burst page.
.IP L
Literal.  The line contains identification info from
the password file and causes the banner page to be printed.
.IP T
Title.  String to be used as the title for
.IR pr (1).
.IP H
Host Name.  Name of the machine where
.I lpr
was invoked.
.IP P
Person.  Login name of the person who invoked
.IR lpr .
This is used to verify ownership by
.IR lprm .
.IP M
Send mail to the specified user when the current print job completes.
.IP f
Formatted File.  Name of a file to print which is already formatted.
.IP l
Like ``f'' but passes control characters and does not make page breaks.
.IP p
Name of a file to print using
.IR pr (1)
as a filter.
.IP t
Troff File.  The file contains
.IR troff (1)
output (cat phototypesetter commands).
.IP n
Ditroff File.  The file contains device independent troff
output.
.IP d
DVI File.  The file contains
.IR Tex (l)
output (DVI format from Standford).
.IP g
Graph File.  The file contains data produced by
.IR plot (3X).
.IP c
Cifplot File. The file contains data produced by
.IR cifplot .
.IP v
The file contains a raster image.
.IP r
The file contains text data with FORTRAN carriage control characters.
.IP 1
Troff Font R. Name of the font file to use instead of the default.
.IP 2
Troff Font I. Name of the font file to use instead of the default.
.IP 3
Troff Font B. Name of the font file to use instead of the default.
.IP 4
Troff Font S. Name of the font file to use instead of the default.
.IP W
Width. Changes the page width (in characters) used by
.IR pr (1)
and the text filters.
.IP I
Indent.  The number of characters to indent the output by (in ascii).
.IP U
Unlink.  Name of file to remove upon completion of printing.
.IP N
File name.  The name of the file which is being printed, or a blank
for the standard input (when 
.I lpr
is invoked in a pipeline).
.in -5
.PP
If a file can not be opened, a message will be logged via
.IR syslog (3)
using the
.I LOG_LPR
facility.
.I Lpd
will try up to 20 times
to reopen a file it expects to be there, after which it will
skip the file to be printed.
.PP
.I Lpd
uses
.IR flock (2)
to provide exclusive access to the lock file and to prevent multiple
deamons from becoming active simultaneously.  If the daemon should be killed
or die unexpectedly, the lock file need not be removed.
The lock file is kept in a readable ASCII form
and contains two lines.
The first is the process id of the daemon and the second is the control
file name of the current job being printed.  The second line is updated to
reflect the current status of
.I lpd
for the programs
.IR lpq (1)
and
.IR lprm (1).
.SH FILES
.nf
.ta \w'/etc/printcap           'u
/etc/printcap	printer description file
/usr/spool/*	spool directories
/usr/spool/*/minfree	minimum free space to leave
/dev/lp*	line printer devices
/dev/printer	socket for local requests
/etc/hosts.equiv	lists machine names allowed printer access
/etc/hosts.lpd	lists machine names allowed printer access,
		but not under same administrative control.
.fi
.SH "SEE ALSO"
lpc(8),
pac(1),
lpr(1),
lpq(1),
lprm(1),
syslog(3),
printcap(5)
.br
.ul
4.2BSD Line Printer Spooler Manual
